//=============================================================================
//
//   File : BKCard.cpp
//   Created on mer 07 ott 2009 19:03:19 by Iacopo Palazzi
//
//   This file is part of the BrisKola distribution
//   Copyright (C) 2009 Iacopo Palazzi <iacopo.palazzi@gmail.com>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#include "BKCard.h"

#include "BK.h"
#include "BKCard.h"
#include "BKPlayer.h"

BKCard::BKCard(unsigned int p_uiSuit, unsigned int p_uiName, unsigned int p_uiValue, unsigned int p_uiPoints, QString p_strImage)
{
	m_uiSuit = p_uiSuit; // 0 - Clubs, 1 - Diamonds, 2 - Hearts, 3 - Spades
	m_uiName = p_uiName; // 0 - Ace, 1 - Two, 2 - Three, 3 - Four, 4 - Five, 5 - Six, 6 - Seven, 7 - Jack, 8 - Queen, 9 - King
	m_uiValue = p_uiValue;
	m_uiPoints = p_uiPoints;
	m_pGSCard = new BKGameSceneItemCard(this, p_strImage);
	m_pGSCard->setZValue(0);
}

BKCard::~BKCard()
{
	if (m_pGSCard) delete m_pGSCard;
}

// ================================
// Start putting your stuff here...
// ================================

QString BKCard::strSuit()
{
	switch(m_uiSuit)
	{
		case 0:
			return QString("Fiori");
		break;
		case 1:
			return QString("Quadri");
		break;
		case 2:
			return QString("Cuori");
		break;
		case 3:
			return QString("Picche");
		break;
	}
	return QString("");
}

QString BKCard::strName()
{
	switch(m_uiName)
	{
		case 0:
			return QString("Asso");
		break;
		case 1:
			return QString("2");
		break;
		case 2:
			return QString("3");
		break;
		case 3:
			return QString("4");
		break;
		case 4:
			return QString("5");
		break;
		case 5:
			return QString("6");
		break;
		case 6:
			return QString("7");
		break;
		case 7:
			return QString("Jack");
		break;
		case 8:
			return QString("Donna");
		break;
		case 9:
			return QString("Re");
		break;
	}
	return QString("");
}

bool BKCard::isLeak()
{
	if (!isLoad() && !isPicture())
		return true;
	return false;
}

bool BKCard::isPicture()
{
	if (m_uiName >= 7 && m_uiName <= 9)
		return true;
	return false;
}

bool BKCard::isLoad()
{
	if (m_uiName == 0 || m_uiName == 2)
		return true;
	return false;
}

void BKCard::clicked()
{
	if (m_pPlayer)
		m_pPlayer->choosenCard(this);
}

void BKCard::detach()
{
	if (m_pPlayer)
		m_pPlayer->takeCard(this);
}

QString BKCard::toString()
{
	return strSuit() + " - " + strName();
}
