#ifndef _BKCARD_H_
#define _BKCARD_H_
//=============================================================================
//
//   File : BKCard.h
//   Created on mer 07 ott 2009 19:03:19 by Iacopo Palazzi
//
//   This file is part of the BrisKola distribution
//   Copyright (C) 2009 Iacopo Palazzi <iacopo.palazzi@gmail.com>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#define CARD_SUIT_CLUBS    0
#define CARD_SUIT_DIAMONDS 1
#define CARD_SUIT_HEARTS   2
#define CARD_SUIT_SPADES   3

#define CARD_NAME_ACE   0
#define CARD_NAME_2     1
#define CARD_NAME_3     2
#define CARD_NAME_4     3
#define CARD_NAME_5     4
#define CARD_NAME_6     5
#define CARD_NAME_7     6
#define CARD_NAME_JACK  7
#define CARD_NAME_QUEEN 8
#define CARD_NAME_KING  9

#include <QString>

#include "BKGameSceneItemCard.h"

class BKPlayer;

class BKCard
{
public:
	BKCard(unsigned int p_uiSuit, unsigned int p_uiName, unsigned int p_uiValue, unsigned int p_uiPoints, QString p_strImage);
	~BKCard();

// ================================
// Put members declaration below...
// ================================
private:
	unsigned int m_uiSuit; // 0 - Clubs, 1 - Diamonds, 2 - Hearts, 3 - Spades
	unsigned int m_uiName; // 0 - Ace, 1 - Two, 2 - Three, 3 - Four, 4 - Five, 5 - Six, 6 - Seven, 7 - Jack, 8 - Queen, 9 - King
	unsigned int m_uiValue;
	unsigned int m_uiPoints;
	
	BKGameSceneItemCard * m_pGSCard;

	BKPlayer * m_pPlayer;

public:

protected:


// ================================
// Put methods declaration below...
// ================================
private:

public:
	unsigned int index() { return (10 * m_uiSuit + m_uiName); };
	BKGameSceneItemCard * card() { return m_pGSCard; };
	
	bool isHidden() { return card()->isHidden(); };
	void setHidden(bool p_bValue) { card()->setHidden(p_bValue); };

	void setVisible(bool p_bValue) { card()->setVisible(p_bValue); };

	unsigned int suit() { return m_uiSuit; };
	unsigned int name() { return m_uiName; };
	unsigned int value() { return m_uiValue; };
	unsigned int points() { return m_uiPoints; };

	QString strSuit();
	QString strName();
	QString toString();

	void setPlayer(BKPlayer * p_pPlayer) { m_pPlayer = p_pPlayer; };
	BKPlayer * player() { return m_pPlayer; };

	bool isLeak();
	bool isPicture();
	bool isLoad();

	void clicked();

	void detach();

protected:



};

#endif //!_BKCARD_H_
