#ifndef _BKCONTROLLER_H_
#define _BKCONTROLLER_H_
//=============================================================================
//
//   File : BKController.h
//   Created on mer 07 ott 2009 17:11:27 by Iacopo Palazzi
//
//   This file is part of the BrisKola distribution
//   Copyright (C) 2009 Iacopo Palazzi <iacopo.palazzi@gmail.com>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#include <stdio.h>
#include <vector>

#include <QObject>
#include <QString>

#include "BK.h"
#include "BKMatch.h"

class BKCard;
class BKPlayer;

class BKController : public QObject
{
	Q_OBJECT
protected:
	BKController();
	~BKController();
	
	enum eState
	{
		STATE_IDLE,
		STATE_PLAYING
	};

// ================================
// Put members declaration below...
// ================================
private:
	eState m_eState;

	BKMatch * m_pMatch;
	
	BKPlayer * m_pPlayerHUM;
	BKPlayer * m_pPlayerCPU;

protected:

public:


// ================================
// Put methods declaration below...
// ================================
private:
	void create();
	void reset();

protected:

public:
	void startGame();
	
	static BKPlayer * getCPU() { return m_pInstance->m_pPlayerCPU; };
	static BKPlayer * getHUM() { return m_pInstance->m_pPlayerHUM; };
	static BKMatch * match() { return m_pInstance->m_pMatch; };
	static void showCPUCards(bool p_bValue);

	static void choosenCard(int p_uiCard);

public slots:
	void sltChoosenCard(BKCard * p_pCard);

// Class follows singleton pattern
protected:
	static BKController * m_pInstance;
public:
	static BKController * instance() { return m_pInstance; };
	static bool init();
	static void done();

};

#endif //!_BKCONTROLLER_H_
