//=============================================================================
//
//   File : BKDeck.cpp
//   Created on mer 07 ott 2009 16:35:43 by Iacopo Palazzi
//
//   This file is part of the BrisKola distribution
//   Copyright (C) 2009 Iacopo Palazzi <iacopo.palazzi@gmail.com>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#include "BKDeck.h"

#include "BKConfig.h"

#include <stdlib.h>

// The one and only BKDeckobject
BKDeck * BKDeck::m_pInstance = NULL;

BKDeck::BKDeck()
{
	m_pCards = NULL;
	
	create();
}

BKDeck::~BKDeck()
{
	for(unsigned int i = 0; i < 40; i++)
		delete m_pCards[i];
	delete [] m_pCards;
}

bool BKDeck::init()
{
	if(m_pInstance)return false;
	m_pInstance = new BKDeck();
	return true;
}

void BKDeck::done()
{
	if(!m_pInstance)return;
	delete m_pInstance;
	m_pInstance = NULL;
}


// ================================
// Start putting your stuff here...
// ================================

void BKDeck::create()
{
	m_pCards = new BKCard * [40];
	
	unsigned int uiCurr;
	for(unsigned int i = 0; i < 4; i++)
	{
		// Iterating throught Suits
		
		for(unsigned int j = 0; j < 10; j++)
		{
			// Iterating throught Names
			
			uiCurr = i * 10 + j;
			
			switch(j)
			{
				// Loads
				case CARD_NAME_ACE:
					m_pCards[uiCurr] = new BKCard(i, j, 9, 11, BKConfig::getCardImage(i, j));
				break;
				case CARD_NAME_3:
					m_pCards[uiCurr] = new BKCard(i, j, 8, 10, BKConfig::getCardImage(i, j));
				break;
				// Points
				case CARD_NAME_KING:
					m_pCards[uiCurr] = new BKCard(i, j, 7, 4, BKConfig::getCardImage(i, j));
				break;
				case CARD_NAME_QUEEN:
					m_pCards[uiCurr] = new BKCard(i, j, 6, 3, BKConfig::getCardImage(i, j));
				break;
				case CARD_NAME_JACK:
					m_pCards[uiCurr] = new BKCard(i, j, 5, 2, BKConfig::getCardImage(i, j));
				break;
				// Leaks
				case CARD_NAME_7:
					m_pCards[uiCurr] = new BKCard(i, j, 4, 0, BKConfig::getCardImage(i, j));
				break;
				case CARD_NAME_6:
					m_pCards[uiCurr] = new BKCard(i, j, 3, 0, BKConfig::getCardImage(i, j));
				break;
				case CARD_NAME_5:
					m_pCards[uiCurr] = new BKCard(i, j, 2, 0, BKConfig::getCardImage(i, j));
				break;
				case CARD_NAME_4:
					m_pCards[uiCurr] = new BKCard(i, j, 1, 0, BKConfig::getCardImage(i, j));
				break;
				case CARD_NAME_2:
					m_pCards[uiCurr] = new BKCard(i, j, 0, 0, BKConfig::getCardImage(i, j));
				break;
			}
			
		}
		
	}
}
