//=============================================================================
//
//   File : BKPlayer.cpp
//   Created on gio 08 ott 2009 14:11:05 by Iacopo Palazzi
//
//   This file is part of the BrisKola distribution
//   Copyright (C) 2009 Iacopo Palazzi <iacopo.palazzi@gmail.com>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#include "BKPlayer.h"

#include "BK.h"
#include "BKDeck.h"

BKPlayer::BKPlayer(BKPlayer::eType p_eType)
	: QObject()
{
	m_eType = p_eType;
	m_pCards = new BKCard * [3];
	m_pCards[0] = m_pCards[1] = m_pCards[2] = NULL;
	
	m_pCardSeen = new bool [40];
	memset(m_pCardSeen, false, sizeof(bool) * 40);
}

BKPlayer::~BKPlayer()
{
	if (m_pCardSeen) delete [] m_pCardSeen;
	if (m_pCards) delete [] m_pCards;
}

void BKPlayer::reset()
{
	m_pCards[0] = m_pCards[1] = m_pCards[2] = NULL;
	memset(m_pCardSeen, false, sizeof(bool) * 40);
}

void BKPlayer::setSeenCard(BKCard * p_pCard)
{
	setSeenCard(p_pCard->suit(), p_pCard->name());
}

void BKPlayer::setSeenCard(unsigned int p_uiSuit, unsigned int p_uiName)
{
	m_pCardSeen[p_uiSuit * 10 + p_uiName] = true;
}

bool BKPlayer::seenCard(BKCard * p_pCard)
{
	return seenCard(p_pCard->suit(), p_pCard->name());
}

bool BKPlayer::seenCard(unsigned int p_uiSuit, unsigned int p_uiName)
{
	return m_pCardSeen[p_uiSuit * 10 + p_uiName];
}
