#ifndef _BKPlayer_h_
#define _BKPlayer_h_
//=============================================================================
//
//   File : BKPlayer.h
//   Created on gio 08 ott 2009 14:11:05 by Iacopo Palazzi
//
//   This file is part of the BrisKola distribution
//   Copyright (C) 2009 Iacopo Palazzi <iacopo.palazzi@gmail.com>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#include <QObject>

class BKCard;

class BKPlayer : public QObject
{
	Q_OBJECT
public:

	enum eType
	{
		PT_HUM,
		PT_CPU
	};

	///
	/// Creates an instance of BKPlayer
	///
	BKPlayer(eType p_eType);

	///
	/// Destroys the instance of BKPlayer
	/// and frees all the relevant resources
	///
	virtual ~BKPlayer();

// ================================
// Put members declaration below...
// ================================
private:
	
public:

protected:
	eType m_eType;
	BKCard ** m_pCards;
	bool * m_pCardSeen;

// ================================
// Put methods declaration below...
// ================================
private:

public:
	virtual void play() = 0;
	virtual void choosenCard(BKCard * p_pCard) = 0;
	virtual void assignCard(BKCard * p_pCard) = 0;
	virtual void takeCard(BKCard * p_pCard) = 0;
	
	void setSeenCard(BKCard * p_pCard);
	void setSeenCard(unsigned int p_uiSuit, unsigned int p_uiName);
	bool seenCard(BKCard * p_pCard);
	bool seenCard(unsigned int p_uiSuit, unsigned int p_uiName);

	BKCard * getCard(unsigned int p_uiIdx) { return m_pCards[p_uiIdx]; };

	void setType(eType p_eType) { m_eType = p_eType; };
	eType type() { return m_eType; };

	void reset();

protected:

signals:
	void sgnCard(BKCard * p_pCard);

}; // class BKPlayer

#endif //!_BKPlayer_h_
