#ifndef _BKPlayerAI_h_
#define _BKPlayerAI_h_
//=============================================================================
//
//   File : BKPlayerAI.h
//   Created on gio 08 ott 2009 16:02:07 by Iacopo Palazzi
//
//   This file is part of the BrisKola distribution
//   Copyright (C) 2009 Iacopo Palazzi <iacopo.palazzi@gmail.com>
//   Copyright (C) 2009 Gianni Sammito <giannixsammito@gmail.com>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#include <QThread>

class BKCard;
class BKPlayerCPU;

class BKPlayerAI : public QThread
{
	Q_OBJECT
public:

	///
	/// Creates an instance of BKPlayerAI
	///
	BKPlayerAI(BKPlayerCPU * p_pParent);

	///
	/// Destroys the instance of BKPlayerAI
	/// and frees all the relevant resources
	///
	~BKPlayerAI();

// ================================
// Put members declaration below...
// ================================
private:
	BKPlayerCPU * m_pParent;

public:

protected:


// ================================
// Put methods declaration below...
// ================================
private:
	void run ();
	BKCard * imFirst();
	BKCard * imSecond();
	
	BKCard * cardHasLessValue(BKCard * p_pCard1, BKCard * p_pCard2);
	unsigned int pointsThatCanTake(BKCard * p_Card);
	unsigned int tryToNotTakeSoft();
	unsigned int tryToNotTakeHard();
	unsigned int maxOpponentPointsHand19ImFirst(BKCard * p_pMyCardPlayed, BKCard * p_pMyOtherCard, BKCard * p_pOppCard1, BKCard * p_pOppCard2);
	unsigned int myMaxPointsHand19ImSecond(BKCard * p_pMyPlayedCard, BKCard * p_pMyOtherCard, BKCard * p_pCardOnTable, BKCard * p_pOppOtherCard);
	unsigned int myMaxPointsHand18ImSecond(BKCard ** p_pMyCards, BKCard ** p_pOppCards);
	unsigned int maxOpponentPointsHand18ImFirst(BKCard ** p_pMyCards, BKCard ** p_pOppCards);
	unsigned int myMaxPointsHand17ImSecond(BKCard ** p_pMyCards, BKCard * p_pCardOnTable, BKCard * p_pBrisKola, BKCard ** p_pCardsNotSeen);
	unsigned int maxOpponentPointsHand17ImFirst(BKCard ** p_pMyCards, BKCard ** p_pCardsNotSeenByMe, BKCard ** p_pCardsNotSeenByOpponent, BKCard * p_pBrisKola);
	bool takesCard(BKCard * p_pCardToPlay, BKCard * p_pCardOnTable);
	bool HUMTakesAndWins(BKCard * p_pCardThatCPUCanPlay, BKCard * p_pCardOnTable);
	bool canTakeWithPointsWithoutBrisKola(BKCard * p_pCardThatCPUCanPlay, BKCard * p_pCardOnTable);
	unsigned int minAmong3(unsigned int p_uiX, unsigned int p_uiY, unsigned int p_uiZ);
	unsigned int maxAmong3(unsigned int p_uiX, unsigned int p_uiY, unsigned int p_uiZ);
	unsigned int maxAmong4(unsigned int p_uiX, unsigned int p_uiY, unsigned int p_uiZ, unsigned int p_uiT);

public:

protected:

}; // class BKPlayerAI

#endif //!_BKPlayerAI_h_
