//=============================================================================
//
//   File : BKPlayerHUM.cpp
//   Created on gio 08 ott 2009 15:01:34 by Iacopo Palazzi
//
//   This file is part of the BrisKola distribution
//   Copyright (C) 2009 Iacopo Palazzi <iacopo.palazzi@gmail.com>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#include "BKPlayerHUM.h"

#include <stdlib.h>

#include "BK.h"
#include "BKGameBoard.h"
#include "BKDeck.h"

BKPlayerHUM::BKPlayerHUM(BKPlayer::eType p_eType)
	: BKPlayer(p_eType)
{
}

BKPlayerHUM::~BKPlayerHUM()
{
}

void BKPlayerHUM::play()
{
}

void BKPlayerHUM::choosenCard(BKCard * p_pCard)
{
	emit sgnCard(p_pCard);
}

void BKPlayerHUM::assignCard(BKCard * p_pCard)
{
	unsigned int i = 0;
	
	p_pCard->setVisible(true);
	p_pCard->setHidden(false);
	p_pCard->setPlayer(this);

	while(m_pCards[i] != NULL && i < 3) { i++; }
	m_pCards[i] = p_pCard;
	
	setSeenCard(p_pCard);
	
	BKGameBoard::placeHUMCard(i, p_pCard);
}

void BKPlayerHUM::takeCard(BKCard * p_pCard)
{
	unsigned int i = 0;
	
	p_pCard->setVisible(false);
	p_pCard->setPlayer(NULL);
	
	while(m_pCards[i] != p_pCard && i < 3) { i++; }
	m_pCards[i] = NULL;
}
