//=============================================================================
//
//   File : BKAbout.cpp
//   Created on mar 06 ott 2009 14:51:56 by Iacopo Palazzi
//
//   This file is part of the BrisKola distribution
//   Copyright (C) 2009 Iacopo Palazzi <iacopo.palazzi@gmail.com>
//   Copyright (C) 2009 Gianni Sammito <giannixsammito@gmail.com>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#include "BKGlobal.h"

#include "BKAbout.h"
#include "BKConfig.h"

#include <QLabel>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QPixmap>
#include <QString>
#include <QTabWidget>
#include <QGridLayout>
#include <QDialogButtonBox>

BKAbout::BKAbout(QWidget * p_pParent)
: QDialog(p_pParent)
{
	m_pTabWidget = NULL;
	m_pProject = NULL;
	m_pCredits = NULL;
	m_pLabel1 = NULL;
	m_pLabel2 = NULL;
	m_pLabel3 = NULL;
	m_pLabel4 = NULL;
	m_pLabelImage = NULL;
	m_pLogo = NULL;
	m_pLabelCreditsDev = NULL;
	m_pLabelCreditsWeb = NULL;
	m_pLabelCreditsOther = NULL;
	m_pLabel_iakko = NULL;
	m_pLabel_SaMMoX = NULL;
	m_pLabel_ellotta = NULL;
	m_pLabel_escape = NULL;
	m_pLabel_burre = NULL;
	m_pLabelMail_iakko = NULL;
	m_pLabelMail_SaMMoX = NULL;
	m_pLabelMail_ellotta = NULL;
	m_pLabelMail_escape = NULL;
	m_pLabelMail_burre = NULL;
	m_pLabel_empty = NULL;
	m_pLabelWebSite = NULL;
	m_pLabelChanIRC = NULL;
	m_pVLayout = NULL;
	m_pHeader = NULL;
	m_pFooter = NULL;
	m_pMainLayout = NULL;
	m_pButtonBox = NULL;
	m_pGridLayout = NULL;

	setWindowModality(Qt::WindowModal);
	setWindowTitle(QString("About BrisKola"));
	m_pTabWidget = new QTabWidget(this);
	
	m_pProject = new QWidget();
	m_pCredits = new QWidget();
	m_pLogo = new QPixmap(_STR_DIR_IMG_ICONS + QString("/briskola-logo.png"));
	
	m_pVLayout = new QVBoxLayout();

	m_pHeader = new QHBoxLayout();
	m_pHeader->setAlignment(Qt::AlignHCenter);	
	m_pFooter = new QHBoxLayout();
	m_pFooter->setAlignment(Qt::AlignRight);
	m_pGridLayout = new QGridLayout(m_pCredits);
	m_pMainLayout = new QVBoxLayout();
	m_pMainLayout->setAlignment(Qt::AlignHCenter);

	m_pLabel1 = new QLabel(tr("BrisKola"));
	m_pLabel2 = new QLabel(tr(QString("Versione " + BKConfig::getString(BKConfig::TXT_VERSION) + " (" + BKConfig::getString(BKConfig::TXT_VERSION_NAME) + ")").toAscii().constData()));
	m_pLabel3 = new QLabel(tr("Copyright 2004-2009"));
	m_pLabel4 = new QLabel(tr("Iacopo Palazzi ed il BrisKola Team"));
	m_pLabelWebSite = new QLabel(tr("Sito internet: <a href='http://www.briskola.net'>www.briskola.net</a>"));
		m_pLabelWebSite->setOpenExternalLinks(true);
	m_pLabelChanIRC = new QLabel(tr("Canale IRC: #briskola sul server irc.freenode.net"));
	m_pLabelCreditsDev = new QLabel(tr("<strong>Sviluppatori</strong>"));
	m_pLabelCreditsWeb = new QLabel(tr("<strong>Webmaster</strong>"));
	m_pLabelCreditsOther = new QLabel(tr("<strong>Beta tester e pacchettizzatori </strong>"));
	m_pLabelImage = new QLabel();
	m_pLabel_iakko = new QLabel(tr("Iacopo Palazzi"));
	m_pLabel_SaMMoX = new QLabel(tr("Gianni Sammito"));
	m_pLabel_ellotta = new QLabel(tr("Matteo Lottaroli"));
	m_pLabel_escape = new QLabel(tr("Daniele Scapellato"));
	m_pLabel_burre = new QLabel(tr("Giovanni Burresi"));
	m_pLabelMail_iakko = new QLabel(tr("<em>&lt;iakko@briskola.net&gt;</em>"));
	m_pLabelMail_SaMMoX = new QLabel(tr("<em>&lt;gianni@briskola.net&gt;</em>"));
	m_pLabelMail_ellotta = new QLabel(tr("<em>&lt;webmaster@briskola.net&gt;</em>"));
	m_pLabelMail_escape = new QLabel(tr("<em>&lt;daniele@briskola.net&gt;</em>"));
	m_pLabelMail_burre = new QLabel(tr("<em>&lt;giovanni@briskola.net&gt;</em>"));
	m_pLabel_empty = new QLabel(tr(""));

	m_pButtonBox = new QDialogButtonBox(Qt::Horizontal, this);
	m_pButtonBox->addButton(QDialogButtonBox::Close);
	
	m_pLabelImage->setPixmap(* m_pLogo);

	m_pVLayout->addWidget(m_pLabel1);
	m_pVLayout->addWidget(m_pLabel2);
	m_pVLayout->addWidget(m_pLabel3);
	m_pVLayout->addWidget(m_pLabel4);
	m_pVLayout->addWidget(m_pLabelWebSite);
	m_pVLayout->addWidget(m_pLabelChanIRC);
	
	m_pProject->setLayout(m_pVLayout);

	m_pGridLayout->addWidget(m_pLabelCreditsDev, 1, 1, Qt::AlignLeft);
	m_pGridLayout->addWidget(m_pLabel_iakko, 2, 1, Qt::AlignLeft);
	m_pGridLayout->addWidget(m_pLabelMail_iakko, 2, 2, Qt::AlignLeft);
	m_pGridLayout->addWidget(m_pLabel_SaMMoX, 3, 1, Qt::AlignLeft);
	m_pGridLayout->addWidget(m_pLabelMail_SaMMoX, 3, 2, Qt::AlignLeft);
	m_pGridLayout->addWidget(m_pLabelCreditsWeb, 4, 1, Qt::AlignLeft);
	m_pGridLayout->addWidget(m_pLabel_ellotta, 5, 1, Qt::AlignLeft);
	m_pGridLayout->addWidget(m_pLabelMail_ellotta, 5, 2, Qt::AlignLeft);
	m_pGridLayout->addWidget(m_pLabelCreditsOther, 6, 1, Qt::AlignLeft);
	m_pGridLayout->addWidget(m_pLabel_escape, 7, 1, Qt::AlignLeft);
	m_pGridLayout->addWidget(m_pLabelMail_escape, 7, 2, Qt::AlignLeft);
	m_pGridLayout->addWidget(m_pLabel_burre, 8, 1, Qt::AlignLeft);
	m_pGridLayout->addWidget(m_pLabelMail_burre, 8, 2, Qt::AlignLeft);
	
	m_pCredits->setLayout(m_pGridLayout);


	m_pTabWidget->addTab(m_pProject, QString("Project"));
	m_pTabWidget->addTab(m_pCredits, QString("Credits"));
	
	m_pHeader->addWidget(m_pLabelImage);
	m_pFooter->addWidget(m_pButtonBox);
	
	m_pMainLayout->addLayout(m_pHeader);
	m_pMainLayout->addWidget(m_pTabWidget);
	m_pMainLayout->addLayout(m_pFooter);
	
	connect(m_pButtonBox, SIGNAL(clicked(QAbstractButton *)), this, SLOT(sltClose()));
	
	setLayout(m_pMainLayout);
	
	setWindowIcon(QIcon(QPixmap(_STR_DIR_IMG_MISC + QString("/bkIcon.png"))));
	
	layout()->setSizeConstraint(QLayout::SetFixedSize);
}

BKAbout::~BKAbout()
{
	if(m_pButtonBox) delete m_pButtonBox;

	if(m_pLabelMail_burre) delete m_pLabelMail_burre;
	if(m_pLabelMail_escape) delete m_pLabelMail_escape;
	if(m_pLabelMail_ellotta) delete m_pLabelMail_ellotta;
	if(m_pLabelMail_SaMMoX) delete m_pLabelMail_SaMMoX;
	if(m_pLabelMail_iakko) delete m_pLabelMail_iakko;

	if(m_pLabel_empty) delete m_pLabel_empty;
	if(m_pLabel_burre) delete m_pLabel_burre;
	if(m_pLabel_escape) delete m_pLabel_escape;
	if(m_pLabel_ellotta) delete m_pLabel_ellotta;
	if(m_pLabel_SaMMoX) delete m_pLabel_SaMMoX;
	if(m_pLabel_iakko) delete m_pLabel_iakko;

	if(m_pLabelImage) delete m_pLabelImage;
	if(m_pLabelCreditsOther) delete m_pLabelCreditsOther;
	if(m_pLabelCreditsWeb) delete m_pLabelCreditsWeb;
	if(m_pLabelCreditsDev) delete m_pLabelCreditsDev;

	if(m_pLabelChanIRC) delete m_pLabelChanIRC;
	if(m_pLabelWebSite) delete m_pLabelWebSite;
	if(m_pLabel4) delete m_pLabel4;
	if(m_pLabel3) delete m_pLabel3;
	if(m_pLabel2) delete m_pLabel2;
	if(m_pLabel1) delete m_pLabel1;

	if(m_pFooter) delete m_pFooter;
	if(m_pHeader) delete m_pHeader;
	if(m_pMainLayout) delete m_pMainLayout;
	if(m_pGridLayout) delete m_pGridLayout;
	if(m_pVLayout) delete m_pVLayout;
	
	if(m_pLogo) delete m_pLogo;
	if(m_pCredits) delete m_pCredits;
	if(m_pProject) delete m_pProject;
	if(m_pTabWidget) delete m_pTabWidget;
}


// ================================
// Start putting your stuff here...
// ================================

void BKAbout::sltClose()
{
	hide();
}
