//=============================================================================
//
//   File : BKAbout.cpp
//   Created on mar 06 ott 2009 14:51:56 by Iacopo Palazzi
//
//   This file is part of the BrisKola distribution
//   Copyright (C) 2009 Iacopo Palazzi <iacopo.palazzi@gmail.com>
//   Copyright (C) 2009 Gianni Sammito <giannixsammito@gmail.com>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#include "BKGlobal.h"

#include "BKAlertNewVersion.h"

#include <QLabel>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QString>
#include <QPushButton>
#include <QDialogButtonBox>
#include <QDesktopServices>
#include <QUrl>

BKAlertNewVersion::BKAlertNewVersion(QWidget * p_pParent)
: QDialog(p_pParent)
{
	m_pLayout = NULL;
	m_pButtonBox = NULL;
	m_pLabelText = NULL;
	
	setWindowModality(Qt::WindowModal);
	setWindowTitle(QString("Aggiornamenti disponibili"));
	
	m_pLayout = new QVBoxLayout();
	m_pButtonBox = new QDialogButtonBox(Qt::Horizontal);
	m_pLabelText = new QLabel(QString(trUtf8("La tua BrisKola non è aggiornata all'ultima versione.\nVisitare la pagina dei download?")));
	
	m_pButtonBox->addButton(QDialogButtonBox::Yes);
	m_pButtonBox->addButton(QDialogButtonBox::No);
	
	setWindowIcon(QIcon(QPixmap(_STR_DIR_IMG_MISC + QString("/bkIcon.png"))));
	
	m_pLayout->addWidget(m_pLabelText);
	m_pLayout->addWidget(m_pButtonBox);
	
	setLayout(m_pLayout);
	
	layout()->setSizeConstraint(QLayout::SetFixedSize);
	
	connect(m_pButtonBox, SIGNAL(accepted()), this, SLOT(sltButtonYes()));
	connect(m_pButtonBox, SIGNAL(rejected()), this, SLOT(sltButtonNo()));
}

BKAlertNewVersion::~BKAlertNewVersion()
{
	if(m_pLabelText) delete m_pLabelText;
	if(m_pButtonBox) delete m_pButtonBox;
	if(m_pLayout) delete m_pLayout;
}


// ================================
// Start putting your stuff here...
// ================================

void BKAlertNewVersion::sltButtonYes()
{
	QDesktopServices::openUrl(QUrl::fromEncoded("http://www.briskola.net/download.php"));
	hide();
}

void BKAlertNewVersion::sltButtonNo()
{
	hide();
}

