#ifndef _BKHELP_H_
#define _BKHELP_H_
//=============================================================================
//
//   File : BKHelp.h
//   Created on mar 06 ott 2009 14:51:56 by Iacopo Palazzi
//
//   This file is part of the BrisKola distribution
//   Copyright (C) 2009 Iacopo Palazzi <iacopo.palazzi@gmail.com>
//   Copyright (C) 2009 Gianni Sammito <giannixsammito@gmail.com>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#include <QWidget>
#include <QDialog>

class QTextEdit;
class QVBoxLayout;
class QHBoxLayout;
class QTabWidget;
class QDialogButtonBox;

class BKHelp : public QDialog
{
	Q_OBJECT
public:
	BKHelp(QWidget * p_pParent);
	~BKHelp();

// ================================
// Put members declaration below...
// ================================
private:
	QWidget * m_pTextBoxRules, * m_pTextBoxHowToPlay;
	QTextEdit * m_pRules, * m_pHowToPlay;
	QDialogButtonBox * m_pButtonBox;
	QVBoxLayout * m_pVLayout;
	QHBoxLayout * m_pFooter;
	QTabWidget * m_pTabWidget;

protected:

public:


// ================================
// Put methods declaration below...
// ================================
private:
	void setRulesText();
	void setHowToPlayText();
	void createRules();
	void createHowToPlay();

protected:

public:

private slots:
	void sltClose();

// Class follows singleton pattern
protected:
	
public:

};

#endif //!_BKHELP_H_
