#ifndef _BKOPTIONS_H_
#define _BKOPTIONS_H_
//=============================================================================
//
//   File : BKOptions.h
//   Created on mar 06 ott 2009 14:51:56 by Iacopo Palazzi
//
//   This file is part of the BrisKola distribution
//   Copyright (C) 2009 Iacopo Palazzi <iacopo.palazzi@gmail.com>
//   Copyright (C) 2009 Gianni Sammito <giannixsammito@gmail.com>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#include <QWidget>
#include <QDialog>

#include "BKAlert.h"

class QVBoxLayout;
class QHBoxLayout;
class QRadioButton;
class QLabel;
class QPixmap;
class QTabWidget;
class QGridLayout;
class QComboBox;
class QSlider;
class QLineEdit;
class QSpinBox;
class QCheckBox;
class QDialogButtonBox;

class BKOptions : public QDialog
{
	Q_OBJECT
public:
	BKOptions(QWidget * p_pParent);
	~BKOptions();

// ================================
// Put members declaration below...
// ================================
private:
	QTabWidget * m_pMainTab;
	QWidget * m_pDeckTab, * m_pBackTab, * m_pKeyTab, * m_pSpeedTab, * m_pGeneralTab;
	QRadioButton ** m_pDeckRadioButton, ** m_pBackRadioButton;
	QLabel * m_pPreview, * m_pBackPreview, * m_pLabelImage, * m_pLabelBackImage;
	QLabel * m_pLabelKey1, * m_pLabelKey2, * m_pLabelKey3;
	QSpinBox * m_pSpinBoxManualSpeed;
	QRadioButton * m_pRadioSpeedHigh, * m_pRadioSpeedNormal, * m_pRadioSpeedSlow, * m_pRadioSpeedManual;
	QPixmap * m_pDeckImage, * m_pBackImage;
	QVBoxLayout * m_pVLayoutLeft, * m_pVLayoutRight, * m_pDeckLayout, * m_pMainLayout;
	QVBoxLayout * m_pVBackLayoutLeft, * m_pVBackLayoutRight, * m_pBackLayout, * m_pSpeedLayout, * m_pGeneralLayout;
	QHBoxLayout * m_pHLayout, * m_pHBackLayout, * m_pFooter, * m_pSpeedFooter;
	QGridLayout * m_pKeyLayout;
	QComboBox * m_pComboBoxKey[3];
	QRadioButton * m_pRadioGeneral[3];
	QSlider * m_pSliderSpeed;
	QCheckBox * m_pCheckBoxGeneralPoints, * m_pCheckBoxGeneralSquare, * m_pCheckDelayCPU;
	QDialogButtonBox * m_pButtonBox;
	BKAlert * m_pWindowAlert;

protected:

public:


// ================================
// Put methods declaration below...
// ================================
private:
	void createDeckTab();
	void createBackTab();
	void createKeyTab();
	void createSpeedTab();
	void createGeneralTab();
	void setComboBox(QComboBox * p_pComboBox);

protected:

public:
	void setCurrentOptionsChecked();

private slots:
	void sltDeck(bool p_bValue);
	void sltBack(bool p_bValue);
	void sltButtonOk();
	void sltButtonReset();
	void sltManualSpeed();
	void sltSlider();
	void sltSpinBox();

// Class follows singleton pattern
protected:
	
public:

};

#endif //!_BKOPTIONS_H_
