#ifndef _BKGAMESCENE_H_
#define _BKGAMESCENE_H_
//=============================================================================
//
//   File : BKGameScene.h
//   Created on mar 06 ott 2009 16:11:54 by Iacopo Palazzi
//
//   This file is part of the BrisKola distribution
//   Copyright (C) 2009 Iacopo Palazzi <iacopo.palazzi@gmail.com>
//   Copyright (C) 2009 Gianni Sammito <giannixsammito@gmail.com>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#include <QGraphicsScene>
#include <QGraphicsSceneMouseEvent>
#include <QRectF>

class QWidget;

class BKCard;

class BKGameScene : public QGraphicsScene
{
	Q_OBJECT
protected:
	BKGameScene(QWidget * p_pParent);
	~BKGameScene();

// ================================
// Put members declaration below...
// ================================
private:

protected:

public:


// ================================
// Put methods declaration below...
// ================================
private:
	void createScene();

	void mouseReleaseEvent ( QGraphicsSceneMouseEvent * mouseEvent );

protected:

public:
	static void reset();

// Class follows singleton pattern
protected:
	static BKGameScene * m_pInstance;
public:
	static BKGameScene * instance() { return m_pInstance; };
	static bool init(QWidget * p_pParent);
	static void done();

signals:
	void sgnCardClicked(BKCard * p_pCard);

};

#endif //!_BKGAMESCENE_H_
