//=============================================================================
//
//   File : BKGameSceneItemcard.cpp
//   Created on mer 07 ott 2009 20:36:13 by Iacopo Palazzi
//
//   This file is part of the BrisKola distribution
//   Copyright (C) 2009 Iacopo Palazzi <iacopo.palazzi@gmail.com>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#include "BKGameSceneItemCard.h"

#include <QPixmap>
#include <QGraphicsSceneMouseEvent>

#include "BK.h"
#include "BKCard.h"
#include "BKConfig.h"

BKGameSceneItemCard::BKGameSceneItemCard(BKCard * p_pParent, QString p_strImage)
	: BKGameSceneItem()
{
	m_pParent = p_pParent;
	m_pImage = new QPixmap(p_strImage);
	m_pHiddenImage = new QPixmap(BKConfig::getImage(BKConfig::IMG_DECK));
	setHidden(false);
	connect(BKConfig::instance(), SIGNAL(sgnDeckChanged()), this, SLOT(doSetDeck()));
}

BKGameSceneItemCard::~BKGameSceneItemCard()
{
	if (m_pImage) delete m_pImage;
	if (m_pHiddenImage) delete m_pHiddenImage;
}

void BKGameSceneItemCard::doSetDeck()
{
	//dbg("%s", m_pParent->toString().toStdString().c_str());
	m_pHiddenImage->load(BKConfig::getImage(BKConfig::IMG_DECK));
	if (isHidden()) setPixmap(*m_pHiddenImage);
}

// ================================
// Start putting your stuff here...
// ================================

void BKGameSceneItemCard::clicked()
{
	m_pParent->clicked();
}
