#ifndef _BKGAMESCENEITEMCARD_H_
#define _BKGAMESCENEITEMCARD_H_
//=============================================================================
//
//   File : BKGameSceneItemcard.h
//   Created on mer 07 ott 2009 20:36:13 by Iacopo Palazzi
//
//   This file is part of the BrisKola distribution
//   Copyright (C) 2009 Iacopo Palazzi <iacopo.palazzi@gmail.com>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#include "BKGameSceneItem.h"

#include <QObject>
#include <QString>

class QPixmap;
class QGraphicsSceneMouseEvent;
class BKCard;

class BKGameSceneItemCard : public BKGameSceneItem
{
	Q_OBJECT
public:
	BKGameSceneItemCard(BKCard * p_pParent, QString p_strImage);
	~BKGameSceneItemCard();

// ================================
// Put members declaration below...
// ================================
private:
	bool m_bHidden;
	BKCard * m_pParent;
	QPixmap * m_pImage;
	QPixmap * m_pHiddenImage;

public:

protected:


// ================================
// Put methods declaration below...
// ================================
private:

public:
	eType type() { return QS_ITM_CARD; };
	void clicked();
	
	BKCard * parent() { return m_pParent; };
	
	bool isHidden() { return m_bHidden; };
	void setHidden(bool p_bValue) { m_bHidden = p_bValue; setPixmap(*(!m_bHidden ? m_pImage : m_pHiddenImage)); };
	
	QPixmap * pixmapVisible() { return m_pImage; };
	QPixmap * pixmapHidden() { return m_pHiddenImage; };

protected:

public slots:
	void doSetDeck();

};

#endif //!_BKGAMESCENEITEMCARD_H_
