#ifndef _BKGAMEVIEW_H_
#define _BKGAMEVIEW_H_
//=============================================================================
//
//   File : BKGameView.h
//   Created on mar 06 ott 2009 16:36:05 by Iacopo Palazzi
//
//   This file is part of the BrisKola distribution
//   Copyright (C) 2009 Iacopo Palazzi <iacopo.palazzi@gmail.com>
//   Copyright (C) 2009 Gianni Sammito <giannixsammito@gmail.com>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#include <QGraphicsView>

class QGraphicsPixmapItem;
class QGraphicsScene;
class QKeyEvent;
class QPainter;
class QPixmap;
class QWidget;

class BKGameView : public QGraphicsView
{
	Q_OBJECT
protected:
	BKGameView(QGraphicsScene * p_pScene, QWidget * p_pParent);
	~BKGameView();

// ================================
// Put members declaration below...
// ================================
private:
	QGraphicsPixmapItem * m_pBackground;
	QPixmap * m_pBackgroundPixmap;

protected:

public:


// ================================
// Put methods declaration below...
// ================================
private:
	void createGraphics();
	void drawBackground(QPainter * painter, const QRectF & rect);

	void keyPressEvent ( QKeyEvent * e );

protected:

public:


// Class follows singleton pattern
protected:
	static BKGameView * m_pInstance;
public:
	static BKGameView * instance() { return m_pInstance; };
	static bool init(QGraphicsScene * p_pScene, QWidget * p_pParent);
	static void done();

public slots:
	void setBackground();

};

#endif //!_BKGAMEVIEW_H_
